#include "X-sok.h"
#include "bruteforce.h"

static void try_recursive(int i, unsigned long rem[128][4]) {
    int x, y, w = arr[i].w;
    for (x = 0; x <= arr[i].mx; ++x) {
	unsigned long m1, m2;	/* masks */
	int off;
	off = x >> 5;			/* x / 32 */
	m1 = ((1UL << w)-1UL) << (x&31);	/* unshifted mask << shift */
	m2 = w + (x&31) > 32 ? (1UL << (w+(x&31)-32))-1UL : 0;

	/* printf("lv %d: x=%2d, m2=0x%08lx, m1=0x%08lx\n", i, x, m2, m1); */
	for (y = 0; y <= arr[i].my; ++y) {
	    int j;
	    for (j = 0; j < arr[i].h; ++j)
		if ((rem[y+j][off] & m1) || (rem[y+j][off+1] & m2))
		    goto noplace;
	    /* place tile! */
	    arr[i].cx = x; arr[i].cy = y;
	    if (i+1 >= widest+improvement) {
		widest = i+1;
		update(i+1);
	    }
	    for (j = 0; j < arr[i].h; ++j) {
		rem[y+j][off] |= m1;
		rem[y+j][off+1] |= m2;
	    }
#if 0
	    printf("New board:\n");
	    for (j = 0; j < P.t[0].height; ++j)
		printf("%08lx\n", rem[j][0]);
#endif    
	    if (i+1 == P.totaltiles) {
		/* found the solution */
		/* longjump! */
		longjmp(jbuf, 1);
	    } else
		try_recursive(i+1, rem);
	    for (j = 0; j < arr[i].h; ++j) {
		rem[y+j][off] &= ~m1;
		rem[y+j][off+1] &= ~m2;
	    }
	noplace:
	    ;
	} /* for y */
    }
}

void cmd_TryAll3(void) {
    int i;
    unsigned long rem[128][4];
    if (P.t[0].width > 128 || P.t[0].height > 128) {
	show_message("Only possible for <= 128*128 rectangles");
	return;	/* due to bitmap */
    }
    
    for (i = 1; i <= P.totaltiles; ++i) {
	arr[i-1].w = P.t[P.position[i].tilenr].width;
	arr[i-1].h = P.t[P.position[i].tilenr].height;
	arr[i-1].mx = P.t[0].width - arr[i-1].w;
	arr[i-1].my = P.t[0].height - arr[i-1].h;
	arr[i-1].cx = arr[i-1].cy = 0;
    }
    arr[0].mx = (arr[0].mx+1) / 2;
    arr[0].my = (arr[0].my+1) / 2;
    memset(rem, 0, sizeof(rem));
    widest = 0;
    if (!setjmp(jbuf))
	try_recursive(0, rem);
    show_message("%d tiles placed", widest);
}
